#include <string.h>
#include <stdio.h>
#include "CString.h"

CString::CString()
	: BString() {}

CString::CString(const char *string)
	: BString(string)
{
}

CString::CString(const char *string, int32 len)
	: BString(string, len)
{
}

CString CString::operator+(const CString& rhs)
{
	CString s = *this;
	s << rhs;
	return s;
}

CString CString::Left(int amount)
{
	return(CString(String(), amount));
}

CString CString::Right(int amount)
{
	int len = GetLength();
	return(CString(String() + len-amount, amount));
}

CString CString::Mid(int mid, int amount)
{
	return(CString(String() + mid, amount));
}

void CString::SetAt(int index, char c)
{
	int len = Length() + 1;
	char *data = LockBuffer(len);
	data[index] = c;
	UnlockBuffer(len);
}

long CString::GetLength()
{
	return strlen(String());
}
