#include <Window.h>
#include <StringView.h>
#include <RadioButton.h>
#include <Button.h>
#include "GBoy.h"
#include "ccimport.h"

const uint32 IDC_EDIT1 = 'ide1';
const uint32 IDC_EDIT2 = 'ide2';
const uint32 IDC_EDIT3 = 'ide3';
const uint32 IDC_EDIT4 = 'ide4';
const uint32 IDC_EDIT5 = 'ide5';
const uint32 IDC_EDIT6 = 'ide6';
const uint32 IDC_EDIT7 = 'ide7';
const uint32 IDC_CLEAR = 'clea';
const uint32 IDC_RADIO1 = 'rad1';
const uint32 IDC_RADIO2 = 'rad2';

static bool ggear = FALSE;

GBoy::GBoy(BRect frame, BWindow *parent, uint32 msg)
	: BWindow(frame, "Game Boy/Game Gear", B_TITLED_WINDOW, B_NOT_ZOOMABLE | B_NOT_RESIZABLE),
	qmsg(msg),
	handle(parent),
	m_gbgg1(""),
	m_gbgg2(""),
	m_gbgg3(""),
	m_gbhx1(""),
	m_gbhx2(""),
	m_gbhx3(""),
	m_gbsc("")
{
	BView *view = new BView(Bounds(), "", B_FOLLOW_ALL, B_WILL_DRAW);
	view->SetViewColor(ui_color(B_PANEL_BACKGROUND_COLOR));
	AddChild(view);
	
	gg1 = new CEdit(BRect(10, 10, 90, 60), "gg1", "GG Code", "", 0);
	gg1->SetModificationMessage(new BMessage(IDC_EDIT1));
	gg1->SetDivider(50);
	gg1->SetMaxChars(3);
	view->AddChild(gg1);
	
	BStringView *sv = new BStringView(BRect(90, 15, 100, 25), "", " --");
	view->AddChild(sv);
	
	gg2 = new CEdit(BRect(100, 10, 130, 60), "gg2", "", "", 0);
	gg2->SetModificationMessage(new BMessage(IDC_EDIT2));
	gg2->SetDivider(0);
	gg2->SetMaxChars(3);
	view->AddChild(gg2);
	
	BStringView *svn = new BStringView(BRect(130, 15, 140, 25), "", " --");
	view->AddChild(svn);
	
	gg3 = new CEdit(BRect(140, 10, 170, 60), "gg3", "", "", 0);
	gg3->SetModificationMessage(new BMessage(IDC_EDIT3));
	gg3->SetDivider(0);
	gg3->SetMaxChars(3);
	view->AddChild(gg3);
	
	hc1 = new CEdit(BRect(10, 40, 100, 60), "hc1", "Hex Code", "", 0);
	hc1->SetModificationMessage(new BMessage(IDC_EDIT4));
	hc1->SetDivider(50);
	hc1->SetMaxChars(4);
	view->AddChild(hc1);
	
	BStringView *sv1 = new BStringView(BRect(102, 35, 108, 55), "", "?");
	view->AddChild(sv1);
	
	hc2 = new CEdit(BRect(110, 40, 140, 60), "hc2", "", "", 0);
	hc2->SetModificationMessage(new BMessage(IDC_EDIT5));
	hc2->SetDivider(0);
	hc2->SetMaxChars(2);
	view->AddChild(hc2);
	
	BStringView *sv2 = new BStringView(BRect(142, 35, 148, 55), "", " :");
	view->AddChild(sv2);
	
	hc3 = new CEdit(BRect(150, 40, 180, 60), "hc3", "", "", 0);
	hc3->SetModificationMessage(new BMessage(IDC_EDIT6));
	hc3->SetDivider(0);
	hc3->SetMaxChars(2);
	view->AddChild(hc3);
	
	gg_gb = new CEdit(BRect(190, 40, 205, 60), "hc3", "", "", 0);
	gg_gb->SetModificationMessage(new BMessage(IDC_EDIT7));
	gg_gb->SetDivider(0);
	gg_gb->SetMaxChars(1);
	view->AddChild(gg_gb);
	
	view->AddChild(new BButton(BRect(210, 10, 260, 30), "", "Clear", new BMessage(IDC_CLEAR)));
	view->AddChild(new BButton(BRect(210, 40, 260, 60), "", "Close", new BMessage(B_QUIT_REQUESTED)));
	
	BRadioButton *radio1 = new BRadioButton(BRect(10, 60, 80, 160), "", "Game Boy", new BMessage(IDC_RADIO1));
	radio1->SetValue(B_CONTROL_ON);
	view->AddChild(radio1);
	
	BRadioButton *radio2 = new BRadioButton(BRect(90, 60, 170, 160), "", "Game Gear", new BMessage(IDC_RADIO2));
	view->AddChild(radio2);
	
	m_gbsc="8";
	gg_gb->SetDlgItemText("8");
}

void GBoy::MessageReceived(BMessage *m)
{
	switch(m->what) {
		case IDC_EDIT1:
			OnChangeEdit1();
		break;
		case IDC_EDIT2:
			OnChangeEdit2();
		break;
		case IDC_EDIT3:
			OnChangeEdit3();
		break;
		case IDC_EDIT4:
			OnChangeEdit4();
		break;
		case IDC_EDIT5:
			OnChangeEdit5();
		break;
		case IDC_EDIT6:
			OnChangeEdit6();
		break;
		case IDC_EDIT7:
			OnChangeEdit7();
		break;
		case IDC_CLEAR:
			gg1->SetText("");
			gg2->SetText("");
			gg3->SetText("");
			hc1->SetText("");
			hc2->SetText("");
			hc3->SetText("");
		break;
		case IDC_RADIO1:
			OnRadio1();
		break;
		case IDC_RADIO2:
			OnRadio2();
		break;
		default:
			BWindow::MessageReceived(m);
		break;
	}
}

void GBoy::OnChangeEdit1() 
{
	CString hresult;

	gg1->GetDlgItemText(m_gbgg1);
	gg2->GetDlgItemText(m_gbgg2);
	gg3->GetDlgItemText(m_gbgg3);
	
	if (!(m_gbgg1.GetLength()==3 && m_gbgg2.GetLength()==3))
	{
		if (m_gbgg1.GetLength()==3)
			gg2->SetFocus();
		return;
	}
	if (m_gbgg3.GetLength()<3 && m_gbgg3.GetLength()>0)
	{
		return;
	}
	if (m_gbgg3.GetLength()==0)
		hresult = GB6GGtoHex(m_gbgg1 + m_gbgg2);
	else
		hresult = GB9GGtoHex(m_gbgg1 + m_gbgg2 + m_gbgg3);
	
	hc1->SetDlgItemText(hresult.Left(4));
	if (hresult.GetLength()==9)
	{
		hc2->SetDlgItemText(hresult.Mid(4,2));
		gg_gb->SetDlgItemText(hresult.Mid(6,1));
	}
	hc3->SetDlgItemText(hresult.Right(2));
}

void GBoy::OnChangeEdit2() 
{
	CString hresult;

	gg1->GetDlgItemText(m_gbgg1);
	gg2->GetDlgItemText(m_gbgg2);
	gg3->GetDlgItemText(m_gbgg3);
	
	if (!(m_gbgg1.GetLength()==3 && m_gbgg2.GetLength()==3))
	{
		return;
	}
	if (m_gbgg3.GetLength()<3 && m_gbgg3.GetLength()>0)
	{
		return;
	}
	if (m_gbgg2.GetLength()==3)
		gg3->SetFocus();

	if (m_gbgg3.GetLength()==0)
		hresult = GB6GGtoHex(m_gbgg1 + m_gbgg2, ggear);
	else
		hresult = GB9GGtoHex(m_gbgg1 + m_gbgg2 + m_gbgg3,ggear);
	
	hc1->SetDlgItemText(hresult.Left(4));
	if (hresult.GetLength()==9)
	{
		hc2->SetDlgItemText(hresult.Mid(4,2));
		gg_gb->SetDlgItemText(hresult.Mid(6,1));
	}
	else
		hc2->SetDlgItemText("");
	hc3->SetDlgItemText(hresult.Right(2));
}

void GBoy::OnChangeEdit3() 
{
	CString hresult;

	gg1->GetDlgItemText(m_gbgg1);
	gg2->GetDlgItemText(m_gbgg2);
	gg3->GetDlgItemText(m_gbgg3);
	
	if (!(m_gbgg1.GetLength()==3 && m_gbgg2.GetLength()==3))
	{
		return;
	}
	if (m_gbgg3.GetLength()<3 && m_gbgg3.GetLength()>0)
	{
		return;
	}
	if (m_gbgg3.GetLength()==0)
		hresult = GB6GGtoHex(m_gbgg1 + m_gbgg2, ggear);
	else
		hresult = GB9GGtoHex(m_gbgg1 + m_gbgg2 + m_gbgg3, ggear);
	
	hc1->SetDlgItemText(hresult.Left(4));
	if (hresult.GetLength()==9)
	{
		hc2->SetDlgItemText(hresult.Mid(4,2));
		gg_gb->SetDlgItemText(hresult.Mid(6,1));
	}
	else
		hc2->SetDlgItemText("");
	hc3->SetDlgItemText(hresult.Right(2));
}

void GBoy::OnChangeEdit4() 
{
	CString gresult;

	hc1->GetDlgItemText(m_gbhx1);
	hc2->GetDlgItemText(m_gbhx2);
	hc3->GetDlgItemText(m_gbhx3);
	
	if (!(m_gbhx1.GetLength()==4 && m_gbhx3.GetLength()==2))
	{
		if (m_gbhx1.GetLength()==4)
			hc2->SetFocus();
		return;
	}
	if (m_gbhx2.GetLength()==1)
	{
		return;
	}
	if (m_gbhx2.GetLength()==0)
		gresult = GB6HextoGG(m_gbhx1 + m_gbhx3, ggear);
	else
		gresult = GB9HextoGG(m_gbhx1 + m_gbhx2 + m_gbsc + m_gbhx3, ggear);
	
	gg1->SetDlgItemText(gresult.Left(3));
	if (gresult.GetLength()==9)
	{
		gg2->SetDlgItemText(gresult.Mid(3,3));
		gg3->SetDlgItemText(gresult.Right(3));
	}
	else
	{
		gg2->SetDlgItemText(gresult.Right(3));
		gg3->SetDlgItemText("");
	}
}

void GBoy::OnChangeEdit5() 
{
	CString gresult;

	hc1->GetDlgItemText(m_gbhx1);
	hc2->GetDlgItemText(m_gbhx2);
	hc3->GetDlgItemText(m_gbhx3);
	
	if (!(m_gbhx1.GetLength()==4 && m_gbhx3.GetLength()==2))
	{
		if (m_gbhx2.GetLength()==2)
			hc3->SetFocus();
		return;
	}
	if (m_gbhx2.GetLength()==1)
	{
		return;
	}
	if (m_gbhx2.GetLength()==0)
		gresult = GB6HextoGG(m_gbhx1 + m_gbhx3, ggear);
	else
		gresult = GB9HextoGG(m_gbhx1 + m_gbhx2 + m_gbsc + m_gbhx3, ggear);
		
	gg1->SetDlgItemText(gresult.Left(3));
	if (gresult.GetLength()==9)
	{
		gg2->SetDlgItemText(gresult.Mid(3,3));
		gg3->SetDlgItemText(gresult.Right(3));
	}
	else
	{
		gg2->SetDlgItemText(gresult.Right(3));
		gg3->SetDlgItemText("");
	}
}

void GBoy::OnChangeEdit6()
{
	CString gresult;

	hc1->GetDlgItemText(m_gbhx1);
	hc2->GetDlgItemText(m_gbhx2);
	hc3->GetDlgItemText(m_gbhx3);
	
	if (!(m_gbhx1.GetLength()==4 && m_gbhx3.GetLength()==2))
	{
		return;
	}
	if (m_gbhx2.GetLength()==1)
	{
		return;
	}
	if (m_gbhx2.GetLength()==0)
		gresult = GB6HextoGG(m_gbhx1 + m_gbhx3, ggear);
	else
		gresult = GB9HextoGG(m_gbhx1 + m_gbhx2 + m_gbsc + m_gbhx3, ggear);
	
	gg1->SetDlgItemText(gresult.Left(3));
	if (gresult.GetLength()==9)
	{
		gg2->SetDlgItemText(gresult.Mid(3,3));
		gg3->SetDlgItemText(gresult.Right(3));
	}
	else
	{
		gg2->SetDlgItemText(gresult.Right(3));
		gg3->SetDlgItemText("");
	}
}

void GBoy::OnChangeEdit7()
{
	gg_gb->GetDlgItemText(m_gbsc);
	if (m_gbsc.GetLength()==1)
		OnChangeEdit4();
}

void GBoy::OnRadio1()
{
	ggear = FALSE;
}

void GBoy::OnRadio2()
{
	ggear = TRUE;
}

void GBoy::Quit()
{
	handle->PostMessage(qmsg);
	handle->Show();
	BWindow::Quit();
}