#include <Window.h>
#include <Application.h>
#include <Button.h>
#include <View.h>
#include <RadioButton.h>
#include <TranslationUtils.h>
#include <PictureButton.h>
#include "BitmapView.h"
#include "Nes.h"
#include "Snes.h"
#include "Genesis.h"
#include "GBoy.h"
#include "GGWin.h"
#include "VertButton.h"

const uint32 SHOW_NES = 'shne';
const uint32 SHOW_SNES = 'shsn';
const uint32 SHOW_GENESIS = 'shge';
const uint32 SHOW_GBGG = 'shgb';


GGWin::GGWin(BRect frame)
	: BWindow(frame, "Game Genie Code Convertor", B_TITLED_WINDOW, B_NOT_ZOOMABLE | B_NOT_RESIZABLE),
	snes(0),
	nes(0),
	gen(0),
	gboy(0)
{
	BBitmap *bitmap = 0;
	BitmapView *nes_bview = 0;
	
	BView *view = new BView(Bounds(), "", B_FOLLOW_ALL, B_WILL_DRAW);
	view->SetViewColor(ui_color(B_PANEL_BACKGROUND_COLOR));
	AddChild(view);
	
	if((bitmap = BTranslationUtils::GetBitmap("res/nes.bmp")) != NULL) {
		nes_bview = new BitmapView(bitmap->Bounds(), bitmap);
		view->AddChild(nes_bview);
		nes_bview->MoveTo(9, 9);
	}
	view->AddChild(new VertButton(" NES", BRect(40, 8, 60, 70), "", "", new BMessage(SHOW_NES)));
	
	if((bitmap = BTranslationUtils::GetBitmap("res/snes.bmp")) != NULL) {
		nes_bview = new BitmapView(bitmap->Bounds(), bitmap);
		view->AddChild(nes_bview);
		nes_bview->MoveTo(69, 9);
	}
	view->AddChild(new VertButton("SNES", BRect(100, 8, 120, 70), "", "", new BMessage(SHOW_SNES)));
	
	if((bitmap = BTranslationUtils::GetBitmap("res/gen.bmp")) != NULL) {
		nes_bview = new BitmapView(bitmap->Bounds(), bitmap);
		view->AddChild(nes_bview);
		nes_bview->MoveTo(129, 9);
	}
	view->AddChild(new VertButton(" GEN", BRect(160, 8, 180, 70), "", "", new BMessage(SHOW_GENESIS)));
	
	if((bitmap = BTranslationUtils::GetBitmap("res/gboy.bmp")) != NULL) {
		nes_bview = new BitmapView(bitmap->Bounds(), bitmap);
		view->AddChild(nes_bview);
		nes_bview->MoveTo(189, 9);
	}
	
	if((bitmap = BTranslationUtils::GetBitmap("res/ggear.bmp")) != NULL) {
		nes_bview = new BitmapView(bitmap->Bounds(), bitmap);
		view->AddChild(nes_bview);
		nes_bview->MoveTo(219, 9);
	}
	view->AddChild(new BButton(BRect(189, 45, 250, 60), "", "GB/GG", new BMessage(SHOW_GBGG)));
	
	if((bitmap = BTranslationUtils::GetBitmap("res/quit.bmp")) != NULL) {
		nes_bview = new BitmapView(bitmap->Bounds(), bitmap);
		view->AddChild(nes_bview);
		nes_bview->MoveTo(269, 9);
	}
	view->AddChild(new VertButton("QUIT", BRect(300, 8, 320, 70), "", "", new BMessage(B_QUIT_REQUESTED)));
}

void GGWin::MessageReceived(BMessage *m)
{
	switch(m->what) {
		case SHOW_NES:
			if(nes != 0) break;
			nes = new Nes(BRect(200, 200, 470, 280), this, 'qsne');
			nes->Show();
			this->Hide();
		break;
		case SHOW_SNES:
			if(snes != 0) break;
			snes = new Snes(BRect(200, 200, 470, 300), this, 'qsne');
			snes->Show();
			this->Hide();
		break;
		case SHOW_GENESIS:
			if(gen != 0) break;
			gen = new Genesis(BRect(200, 200, 470, 280), this, 'qsne');
			gen->Show();
			this->Hide();
		break;
		case SHOW_GBGG:
			if(gboy != 0) break;
			gboy = new GBoy(BRect(200, 200, 470, 280), this, 'qsne');
			gboy->Show();
			this->Hide();
		break;
		case 'qsne':
			snes = 0;
			nes = 0;
			gen = 0;
			gboy = 0;
		break;
		default:
			BWindow::MessageReceived(m);
		break;
	}
}