#include <Window.h>
#include <StringView.h>
#include <Button.h>
#include "Genesis.h"
#include "ccimport.h"

const uint32 IDC_EDIT1 = 'ide1';
const uint32 IDC_EDIT2 = 'ide2';
const uint32 IDC_EDIT3 = 'ide3';
const uint32 IDC_EDIT4 = 'ide4';
const uint32 IDC_CLEAR = 'clea';

Genesis::Genesis(BRect frame, BWindow *parent, uint32 msg)
	: BWindow(frame, "Genesis", B_TITLED_WINDOW, B_NOT_ZOOMABLE | B_NOT_RESIZABLE),
	qmsg(msg),
	handle(parent),
	m_ggg1(""),
	m_ggg2(""),
	m_ghx1(""),
	m_ghx2("")
{
	BView *view = new BView(Bounds(), "", B_FOLLOW_ALL, B_WILL_DRAW);
	view->SetViewColor(ui_color(B_PANEL_BACKGROUND_COLOR));
	AddChild(view);
	
	gg1 = new CEdit(BRect(10, 10, 100, 60), "gg1", "GG Code", "", 0);
	gg1->SetModificationMessage(new BMessage(IDC_EDIT1));
	gg1->SetDivider(50);
	gg1->SetMaxChars(4);
	view->AddChild(gg1);
	
	BStringView *sv = new BStringView(BRect(100, 15, 110, 25), "", " --");
	view->AddChild(sv);
	
	gg2 = new CEdit(BRect(110, 10, 150, 60), "gg2", "", "", 0);
	gg2->SetModificationMessage(new BMessage(IDC_EDIT2));
	gg2->SetDivider(0);
	gg2->SetMaxChars(4);
	view->AddChild(gg2);
	
	hc1 = new CEdit(BRect(10, 40, 110, 60), "hc1", "Hex Code", "", 0);
	hc1->SetModificationMessage(new BMessage(IDC_EDIT3));
	hc1->SetMaxChars(6);
	view->AddChild(hc1);
	BStringView *sv1 = new BStringView(BRect(112, 35, 120, 55), "", " :");
	view->AddChild(sv1);
	
	hc2 = new CEdit(BRect(120, 40, 165, 60), "hc2", "", "", 0);
	hc2->SetModificationMessage(new BMessage(IDC_EDIT4));
	hc2->SetDivider(0);
	hc2->SetMaxChars(4);
	view->AddChild(hc2);
	
	view->AddChild(new BButton(BRect(200, 10, 250, 30), "", "Clear", new BMessage(IDC_CLEAR)));
	view->AddChild(new BButton(BRect(200, 40, 250, 60), "", "Close", new BMessage(B_QUIT_REQUESTED)));
}

void Genesis::MessageReceived(BMessage *m)
{
		switch(m->what) {
		case IDC_EDIT1:
			OnChangeEdit1();
		break;
		case IDC_EDIT2:
			OnChangeEdit2();
		break;
		case IDC_EDIT3:
			OnChangeEdit3();
		break;
		case IDC_EDIT4:
			OnChangeEdit4();
		break;
		case IDC_CLEAR:
			gg1->SetText("");
			gg2->SetText("");
			hc1->SetText("");
			hc2->SetText("");
		break;
		default:
			BWindow::MessageReceived(m);
		break;
	}
}

void Genesis::OnChangeEdit1() 
{
	CString hresult;
	int i;

	gg1->GetDlgItemText(m_ggg1);
	gg2->GetDlgItemText(m_ggg2);
	
	if (!(m_ggg1.GetLength()==4 && m_ggg2.GetLength()==4))
	{
		if (m_ggg1.GetLength()==4)
			gg2->SetFocus();
		return;
	}
	hresult = GenGGtoHex(m_ggg1 + m_ggg2);
	m_ghx1="      ";
	m_ghx2="    ";
	for (i=0;i<=5;i++)
	{
		m_ghx1.SetAt(i,hresult[i]);
	}
	for (i=0;i<=3;i++)
	{
		m_ghx2.SetAt(i,hresult[i+6]);
	}
	hc1->SetDlgItemText(m_ghx1);
	hc2->SetDlgItemText(m_ghx2);
}

void Genesis::OnChangeEdit2() 
{
	CString hresult;
	int i;

	gg1->GetDlgItemText(m_ggg1);
	gg2->GetDlgItemText(m_ggg2);
	
	if (!(m_ggg1.GetLength()==4 && m_ggg2.GetLength()==4))
	{
		return;
	}
	hresult = GenGGtoHex(m_ggg1 + m_ggg2);
	m_ghx1="      ";
	m_ghx2="    ";
	for (i=0;i<=5;i++)
	{
		m_ghx1.SetAt(i,hresult[i]);
	}
	for (i=0;i<=3;i++)
	{
		m_ghx2.SetAt(i,hresult[i+6]);
	}
	hc1->SetDlgItemText(m_ghx1);
	hc2->SetDlgItemText(m_ghx2);
}

void Genesis::OnChangeEdit3() 
{
	CString gresult;
	int i;

	hc1->GetDlgItemText(m_ghx1);
	hc2->GetDlgItemText(m_ghx2);
	
	if (!(m_ghx1.GetLength()==6 && m_ghx2.GetLength()==4))
	{
		if (m_ghx1.GetLength()==6)
			hc2->SetFocus();
		return;
	}
	gresult = GenHextoGG(m_ghx1 + m_ghx2);
	m_ggg1="    ";
	m_ggg2="    ";
	for (i=0;i<=3;i++)
	{
		m_ggg1.SetAt(i,gresult[i]);
		m_ggg2.SetAt(i,gresult[i+4]);
	}
	gg1->SetDlgItemText(m_ggg1);
	gg2->SetDlgItemText(m_ggg2);
}

void Genesis::OnChangeEdit4() 
{
	CString gresult;
	int i;

	hc1->GetDlgItemText(m_ghx1);
	hc2->GetDlgItemText(m_ghx2);
	
	if (!(m_ghx1.GetLength()==6 && m_ghx2.GetLength()==4))
	{
		return;
	}
	gresult = GenHextoGG(m_ghx1 + m_ghx2);
	m_ggg1="    ";
	m_ggg2="    ";
	for (i=0;i<=3;i++)
	{
		m_ggg1.SetAt(i,gresult[i]);
		m_ggg2.SetAt(i,gresult[i+4]);
	}
	gg1->SetDlgItemText(m_ggg1);
	gg2->SetDlgItemText(m_ggg2);
}

void Genesis::Quit()
{
	handle->PostMessage(qmsg);
	handle->Show();
	BWindow::Quit();
}