#include "VertButton.h"
#include <String.h>
#include <stdio.h>

VertButton::VertButton(const char *vert_label, BRect frame, const char *name, const char *label, BMessage *message,
		uint32 resizeMask = B_FOLLOW_LEFT | B_FOLLOW_TOP, uint32 flags = B_WILL_DRAW | B_NAVIGABLE)
	: BButton(frame, name, label, message, resizeMask, flags),
	v_label(vert_label),
	fheight(0)
{
	font_height info;
	GetFontHeight(&info);
	float h = ceil(info.ascent) + ceil(info.descent);
	h -= 2;
	SetHeight(h);
}

void VertButton::Draw(BRect updateRect)
{
	BButton::Draw(updateRect);
	
	int len = strlen(v_label);
	BPoint p(7, 15);
	for(int i = 0; i < len; i++) {
		DrawChar(v_label[i], p);
		p.y += GetHeight();
	}
}