// ConverterCore.cpp : Defines the initialization routines for the DLL.
//

//#include "stdafx.h"
//#include "ConverterCore.h"

#include "math.h"	//pow() function
#include "itoabeos.h"
#include "CString.h"
#include <ctype.h>
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//
//	Note!
//
//		If this DLL is dynamically linked against the MFC
//		DLLs, any functions exported from this DLL which
//		call into MFC must have the AFX_MANAGE_STATE macro
//		added at the very beginning of the function.
//
//		For example:
//
//		extern "C" BOOL PASCAL EXPORT ExportedFunction()
//		{
//			AFX_MANAGE_STATE(AfxGetStaticModuleState());
//			// normal function body here
//		}
//
//		It is very important that this macro appear in each
//		function, prior to any calls into MFC.  This means that
//		it must appear as the first statement within the 
//		function, even before any object variable declarations
//		as their constructors may generate calls into the MFC
//		DLL.
//
//		Please see MFC Technical Notes 33 and 58 for additional
//		details.
//

/////////////////////////////////////////////////////////////////////////////
// CConverterCoreApp

//BEGIN_MESSAGE_MAP(CConverterCoreApp, CWinApp)
	//{{AFX_MSG_MAP(CConverterCoreApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
//END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CConverterCoreApp construction

//CConverterCoreApp::CConverterCoreApp()
//{
//	// TODO: add construction code here,
//	// Place all significant initialization in InitInstance
//}

/////////////////////////////////////////////////////////////////////////////
// The one and only CConverterCoreApp object

//CConverterCoreApp theApp;

#define DLLExport __declspec(dllexport)

//------------------
//General functions

//chtoi takes a character 0-F and spits out the
//decimal equivalent (think Character Hex TO Int)
DLLExport int chtoi(char hexchar)
{
	if (hexchar >= '0' && hexchar <= '9')
		return hexchar-48;
	if (hexchar >= 'A' && hexchar <= 'F')
		return hexchar-55;
	return -1;
}

//ahtoui takes an entire CString of characters
//0-F and produces the decimal value. It isn't
//used within this library, but it's a darn nice
//thing to have. Think "ASCII Hex TO Unsigned Int"
DLLExport unsigned int ahtoui(CString hexstring)
{
	//AFX_MANAGE_STATE(AfxGetStaticModuleState());

	int x;
	int n = hexstring.GetLength() - 1;
	unsigned int ttl = 0;

	for (x=0;x<=n;x++)
	{
		if (chtoi(hexstring[x])==-1)
			return 0;
	}
	for (x=0;x<=n;x++)
		ttl += chtoi(hexstring[x]) * (unsigned int)pow((double)16,(double)(n-x));
	return ttl;
}

//---------------------------
//NES functions

//This takes an NES GG character and produces its
//decimal value, or -1 if the character is invalid
static int NESGetVal(char NESGGchar)
{
	switch (NESGGchar)
	{
		case 'A':
			return 0;
			break;
		case 'P':
			return 1;
			break;
		case 'Z':
			return 2;
			break;
		case 'L':
			return 3;
			break;
		case 'G':
			return 4;
			break;
		case 'I':
			return 5;
			break;
		case 'T':
			return 6;
			break;
		case 'Y':
			return 7;
			break;
		case 'E':
			return 8;
			break;
		case 'O':
			return 9;
			break;
		case 'X':
			return 10;
			break;
		case 'U':
			return 11;
			break;
		case 'K':
			return 12;
			break;
		case 'S':
			return 13;
			break;
		case 'V':
			return 14;
			break;
		case 'N':
			return 15;
			break;
		default:
			return -1;
			break;
	}
}

//This takes a decimal value 0-15 and returns the
//associated NES GG char, or 'd' if the value is
//out of range
static char NESGetChar(int NEShexval)
{
	switch (NEShexval)
	{
		case 0:
			return 'A';
			break;
		case 1:
			return 'P';
			break;
		case 2:
			return 'Z';
			break;
		case 3:
			return 'L';
			break;
		case 4:
			return 'G';
			break;
		case 5:
			return 'I';
			break;
		case 6:
			return 'T';
			break;
		case 7:
			return 'Y';
			break;
		case 8:
			return 'E';
			break;
		case 9:
			return 'O';
			break;
		case 10:
			return 'X';
			break;
		case 11:
			return 'U';
			break;
		case 12:
			return 'K';
			break;
		case 13:
			return 'S';
			break;
		case 14:
			return 'V';
			break;
		case 15:
			return 'N';
			break;
		default:
			return 'd';
			break;
	}
}

//This reads in a CString of 6 NES GG characters
//and returns a CString containing the 6 hex
//characters of the internal code. The return
//value is kinda like a PAR code: AAAADD. Note
//that "------" is returned if the input code is
//invalid
DLLExport CString NES6GGtoHex(CString NGG6code)
{
	//AFX_MANAGE_STATE(AfxGetStaticModuleState());

	CString hresult="      ";
	char tstring[2]="";
	int mval=0;
	
	//Make sure all characters are in the GG set
	for (mval=0;mval<=5;mval++)
	{
		if (NESGetVal(NGG6code[mval])==-1)
			return "------";
	}

	//Hex char 1 = lower 3 bits of GG char 4
	//(would also have been upper bit of GG char
	//3, but that one isn't used)
	mval=NESGetVal(NGG6code[3])&7;
	_itoa(mval,tstring,16);
	hresult.SetAt(0,tstring[0]);

	//Hex char 2 = lower 3 bits of GG char 6 and
	//upper bit of GG char 5
	mval=(NESGetVal(NGG6code[5])&7)|(NESGetVal(NGG6code[4])&8);
	_itoa(mval,tstring,16);
	hresult.SetAt(1,tstring[0]);

	//H3 = lower 3 of G3 and upper of G2
	mval=(NESGetVal(NGG6code[2])&7)|(NESGetVal(NGG6code[1])&8);
	_itoa(mval,tstring,16);
	hresult.SetAt(2,tstring[0]);

	//H4 = lower 3 of G5 and upper of G4
	mval=(NESGetVal(NGG6code[4])&7)|(NESGetVal(NGG6code[3])&8);
	_itoa(mval,tstring,16);
	hresult.SetAt(3,tstring[0]);

	//H5 = lower 3 of G2 and upper of G1
	mval=(NESGetVal(NGG6code[1])&7)|(NESGetVal(NGG6code[0])&8);
	_itoa(mval,tstring,16);
	hresult.SetAt(4,tstring[0]);

	//H6 = lower 3 of G1 and upper of G6
	mval=(NESGetVal(NGG6code[0])&7)|(NESGetVal(NGG6code[5])&8);
	_itoa(mval,tstring,16);
	hresult.SetAt(5,tstring[0]);

	return hresult;
}

//Pretty much the same as the last one, this takes
//an 8 character GG code in a CString and returns
//a CString containing the hex code, format
//AAAACCDD. That's 4 of address, 2 of check byte,
//and 2 of data byte. Again, invalid codes become
//"--------"
DLLExport CString NES8GGtoHex(CString NGG8code)
{
	//AFX_MANAGE_STATE(AfxGetStaticModuleState());

	CString hresult="        ";
	char tstring[2]="";
	int mval=0;
	
	//Same error checking... Get used to seeing
	//this over and over again
	for (mval=0;mval<=7;mval++)
	{
		if (NESGetVal(NGG8code[mval])==-1)
			return "--------";
	}

	//The first four hex digits are produced the
	//same way as before
	mval=NESGetVal(NGG8code[3])&7;
	_itoa(mval,tstring,16);
	hresult.SetAt(0,tstring[0]);

	mval=(NESGetVal(NGG8code[5])&7)|(NESGetVal(NGG8code[4])&8);
	_itoa(mval,tstring,16);
	hresult.SetAt(1,tstring[0]);

	mval=(NESGetVal(NGG8code[2])&7)|(NESGetVal(NGG8code[1])&8);
	_itoa(mval,tstring,16);
	hresult.SetAt(2,tstring[0]);

	mval=(NESGetVal(NGG8code[4])&7)|(NESGetVal(NGG8code[3])&8);
	_itoa(mval,tstring,16);
	hresult.SetAt(3,tstring[0]);

	//H5 = lower 3 of G8 and upper of G7
	mval=(NESGetVal(NGG8code[7])&7)|(NESGetVal(NGG8code[6])&8);
	_itoa(mval,tstring,16);
	hresult.SetAt(4,tstring[0]);

	//H6 = lower 3 of G7 and upper of G6
	mval=(NESGetVal(NGG8code[6])&7)|(NESGetVal(NGG8code[5])&8);
	_itoa(mval,tstring,16);
	hresult.SetAt(5,tstring[0]);

	//H7 = lower 3 of G2 and upper of G1
	mval=(NESGetVal(NGG8code[1])&7)|(NESGetVal(NGG8code[0])&8);
	_itoa(mval,tstring,16);
	hresult.SetAt(6,tstring[0]);

	//H8 = lower 3 of G1 and upper of G8
	mval=(NESGetVal(NGG8code[0])&7)|(NESGetVal(NGG8code[7])&8);
	_itoa(mval,tstring,16);
	hresult.SetAt(7,tstring[0]);

	return hresult;
}

//This takes a CString containing hex digits in
//AAAADD order and produces the GG code as a
//CString. You can guess the error return value
//by now
DLLExport CString NES6HextoGG(CString NHex6code)
{
	//AFX_MANAGE_STATE(AfxGetStaticModuleState());

	CString gresult="      ";
	int i;

	for (i=0;i<=5;i++)
	{
		if (chtoi(NHex6code[i])==-1)
			return "------";
	}

	//G1 = lower 3 of H6 and upper of H5
	gresult.SetAt(0,NESGetChar((chtoi(NHex6code[5])&7)|(chtoi(NHex6code[4])&8)));
	//G2 = lower 3 of H5 and upper of H3
	gresult.SetAt(1,NESGetChar((chtoi(NHex6code[4])&7)|(chtoi(NHex6code[2])&8)));
	//G3 = lower 3 of H3, upper always 0
	gresult.SetAt(2,NESGetChar(chtoi(NHex6code[2])&7));
	//G4 = lower 3 of H1 and upper of H4
	gresult.SetAt(3,NESGetChar((chtoi(NHex6code[0])&7)|(chtoi(NHex6code[3])&8)));
	//G5 = lower 3 of H4 and upper of H2
	gresult.SetAt(4,NESGetChar((chtoi(NHex6code[3])&7)|(chtoi(NHex6code[1])&8)));
	//G6 = lower 3 of H2 and upper of H6
	gresult.SetAt(5,NESGetChar((chtoi(NHex6code[1])&7)|(chtoi(NHex6code[5])&8)));

	return gresult;
}

//Same as last time, takes a CString containing
//hex digits in AAAACCDD order and makes a CString
//with the GG code
DLLExport CString NES8HextoGG(CString NHex8code)
{
	//AFX_MANAGE_STATE(AfxGetStaticModuleState());

	CString gresult="        ";
	int i;

	for (i=0;i<=7;i++)
	{
		if (chtoi(NHex8code[i])==-1)
			return "--------";
	}

	//G1 = lower 3 of H8 and upper of H7
	gresult.SetAt(0,NESGetChar((chtoi(NHex8code[7])&7)|(chtoi(NHex8code[6])&8)));
	//G2 = lower 3 of H7 and upper of H3
	gresult.SetAt(1,NESGetChar((chtoi(NHex8code[6])&7)|(chtoi(NHex8code[2])&8)));
	//G3 = lower 3 of H3, upper always 1
	gresult.SetAt(2,NESGetChar((chtoi(NHex8code[2])&7)|8));
	//G4 = lower 3 of H1 and upper of H4
	gresult.SetAt(3,NESGetChar((chtoi(NHex8code[0])&7)|(chtoi(NHex8code[3])&8)));
	//G5 = lower 3 of H4 and upper of H2
	gresult.SetAt(4,NESGetChar((chtoi(NHex8code[3])&7)|(chtoi(NHex8code[1])&8)));
	//G6 = lower 3 of H2 and upper of H6
	gresult.SetAt(5,NESGetChar((chtoi(NHex8code[1])&7)|(chtoi(NHex8code[5])&8)));
	//G7 = lower 3 of H6 and upper of H5
	gresult.SetAt(6,NESGetChar((chtoi(NHex8code[5])&7)|(chtoi(NHex8code[4])&8)));
	//G8 = lower 3 of H5 and upper of H8
	gresult.SetAt(7,NESGetChar((chtoi(NHex8code[4])&7)|(chtoi(NHex8code[7])&8)));

	return gresult;
}

//-------------------
//SNES functions
static int SNESGetVal(char SNESGGchar)
{
	switch (SNESGGchar)
	{
		case 'D':
			return 0;
			break;
		case 'F':
			return 1;
			break;
		case '4':
			return 2;
			break;
		case '7':
			return 3;
			break;
		case '0':
			return 4;
			break;
		case '9':
			return 5;
			break;
		case '1':
			return 6;
			break;
		case '5':
			return 7;
			break;
		case '6':
			return 8;
			break;
		case 'B':
			return 9;
			break;
		case 'C':
			return 10;
			break;
		case '8':
			return 11;
			break;
		case 'A':
			return 12;
			break;
		case '2':
			return 13;
			break;
		case '3':
			return 14;
			break;
		case 'E':
			return 15;
			break;
		default:
			return -1;
			break;
	}
}

static char SNESGetChar(int SNEShexval)
{
	switch (SNEShexval)
	{
		case 0:
			return 'D';
			break;
		case 1:
			return 'F';
			break;
		case 2:
			return '4';
			break;
		case 3:
			return '7';
			break;
		case 4:
			return '0';
			break;
		case 5:
			return '9';
			break;
		case 6:
			return '1';
			break;
		case 7:
			return '5';
			break;
		case 8:
			return '6';
			break;
		case 9:
			return 'B';
			break;
		case 10:
			return 'C';
			break;
		case 11:
			return '8';
			break;
		case 12:
			return 'A';
			break;
		case 13:
			return '2';
			break;
		case 14:
			return '3';
			break;
		case 15:
			return 'E';
			break;
		default:
			return 'd';
			break;
	}
}

DLLExport CString SNESGGtoHex(CString SGGcode)
{
	//AFX_MANAGE_STATE(AfxGetStaticModuleState());

	CString hresult="        ";
	char tchar[2]="";
	unsigned int mval=0;

	for (mval=0;mval<=7;mval++)
	{
		if (SNESGetVal(SGGcode[(int) mval])==-1)
			return "--------";
	}
	
	//The first GG character is the first data digit
	_itoa(SNESGetVal(SGGcode[0]),tchar,16);
	hresult.SetAt(6,tchar[0]);
	//The second GG char is the second data digit
	_itoa(SNESGetVal(SGGcode[1]),tchar,16);
	hresult.SetAt(7,tchar[0]);
	//The third is the third address digit
	_itoa(SNESGetVal(SGGcode[2]),tchar,16);
	hresult.SetAt(2,tchar[0]);
	//The fourth is the fifth address digit
	_itoa(SNESGetVal(SGGcode[3]),tchar,16);
	hresult.SetAt(4,tchar[0]);
	//The last 4 characters are rotated two
	//bits to the left to get address digits
	//1, 6, 2, and 4, in that order. The real
	//rotate didn't work, so I faked with
	//shift and AND
	mval = SNESGetVal(SGGcode[7]);
	mval |= (SNESGetVal(SGGcode[6])<<4);
	mval |= (SNESGetVal(SGGcode[5])<<8);
	mval |= (SNESGetVal(SGGcode[4])<<12);
	mval <<= 2;
	mval |= (SNESGetVal(SGGcode[4])&12)>>2;
	mval &= 65535;
	_itoa((mval&61440)>>12,tchar,16);
	hresult.SetAt(0,tchar[0]);
	_itoa((mval&3840)>>8,tchar,16);
	hresult.SetAt(5,tchar[0]);
	_itoa((mval&240)>>4,tchar,16);
	hresult.SetAt(1,tchar[0]);
	_itoa(mval&15,tchar,16);
	hresult.SetAt(3,tchar[0]);

	return hresult;
}

DLLExport CString SNESHextoGG(CString SHexcode)
{
	//AFX_MANAGE_STATE(AfxGetStaticModuleState());

	CString gresult="        ";
	unsigned int mval=0;

	for (mval=0;mval<=7;mval++)
	{
		if (chtoi(SHexcode[(int) mval])==-1)
			return "--------";
	}

	gresult.SetAt(0,SNESGetChar(chtoi(SHexcode[6])));
	gresult.SetAt(1,SNESGetChar(chtoi(SHexcode[7])));
	gresult.SetAt(2,SNESGetChar(chtoi(SHexcode[2])));
	gresult.SetAt(3,SNESGetChar(chtoi(SHexcode[4])));
	mval = chtoi(SHexcode[3]);
	mval |= (chtoi(SHexcode[1])<<4);
	mval |= (chtoi(SHexcode[5])<<8);
	mval |= (chtoi(SHexcode[0])<<12);
	mval >>= 2;
	mval |= (chtoi(SHexcode[3])&3)<<14;
	gresult.SetAt(4,SNESGetChar((mval&61440)>>12));
	gresult.SetAt(5,SNESGetChar((mval&3840)>>8));
	gresult.SetAt(6,SNESGetChar((mval&240)>>4));
	gresult.SetAt(7,SNESGetChar(mval&15));

	return gresult;
}

DLLExport CString SNES64to32(CString hexcode) 
{
	//AFX_MANAGE_STATE(AfxGetStaticModuleState());

	char tchar[4]="";
	char tchar2[2]="";
	int i;

	for (i=0;i<=7;i++)
	{
		if (chtoi(hexcode[i])==-1)
			return "--------";
	}

	i=(16*chtoi(hexcode[0]))+chtoi(hexcode[1]);
	if (i <= 0x60)
		i -= 0x40;
	else
		i -= 0xC0;
	i *= 2;
	if (hexcode[2] >= '8')
		i++;
	if (hexcode[0] <= '6')
		_itoa(i,tchar,16);
	else
		_itoa(0x80+i,tchar,16);
	if (hexcode[2]<'8')
	{
		_itoa(chtoi(hexcode[2])+8,tchar2,16);
		tchar[2]=tchar2[0];
	}
	else
		tchar[2]=hexcode[2];
	hexcode.SetAt(0,toupper(tchar[0]));
	hexcode.SetAt(1,toupper(tchar[1]));
	hexcode.SetAt(2,toupper(tchar[2]));
	return hexcode;
}

DLLExport CString SNES32to64(CString hexcode) 
{
	//AFX_MANAGE_STATE(AfxGetStaticModuleState());

	char tchar[4]="";
	char tchar2[2]="";
	int i;
	
	for (i=0;i<=7;i++)
	{
		if (chtoi(hexcode[i])==-1)
			return "--------";
	}

	i=(16*chtoi(hexcode[0]))+chtoi(hexcode[1]);
	if (i >= 0x80)
	{
		i-=0x80;
		_itoa(0xC0+(i/2),tchar,16);
	}
	else
		_itoa(0x40+(i/2),tchar,16);
	if (i%2)
		tchar[2]=hexcode[2];
	else
	{
		_itoa(chtoi(hexcode[2])-8,tchar2,16);
		tchar[2]=tchar2[0];
	}
	hexcode.SetAt(0,toupper(tchar[0]));
	hexcode.SetAt(1,toupper(tchar[1]));
	hexcode.SetAt(2,toupper(tchar[2]));
	return hexcode;
}

DLLExport CString SNESHexA15Flip(CString hexcode)
{
	//AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	char tchar[2];
	int i;

	for (i=0;i<=7;i++)
	{
		if (chtoi(hexcode[i])==-1)
			return "--------";
	}
	
	if (chtoi(hexcode[2])>=8)
		_itoa(chtoi(hexcode[2])-8,tchar,16);
	else
		_itoa(chtoi(hexcode[2])+8,tchar,16);
	hexcode.SetAt(2,tchar[0]);
	
	return hexcode;
}

DLLExport CString SNESGGA15Flip(CString ggcode)
{
	//AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	int i;

	for (i=0;i<=7;i++)
	{
		if (chtoi(ggcode[i])==-1)
			return "--------";
	}

	if (SNESGetVal(ggcode[2])>=8)
		ggcode.SetAt(2,SNESGetChar(SNESGetVal(ggcode[2])-8));
	else
		ggcode.SetAt(2,SNESGetChar(SNESGetVal(ggcode[2])+8));
	
	return ggcode;
}

//-------------------
//Genesis functions
static int GenGetVal(char GenGGchar)
{
	switch(GenGGchar)
	{
		case 'A':
			return 0;
			break;
		case 'B':
			return 1;
			break;
		case 'C':
			return 2;
			break;
		case 'D':
			return 3;
			break;
		case 'E':
			return 4;
			break;
		case 'F':
			return 5;
			break;
		case 'G':
			return 6;
			break;
		case 'H':
			return 7;
			break;
		case 'J':
			return 8;
			break;
		case 'K':
			return 9;
			break;
		case 'L':
			return 10;
			break;
		case 'M':
			return 11;
			break;
		case 'N':
			return 12;
			break;
		case 'P':
			return 13;
			break;
		case 'R':
			return 14;
			break;
		case 'S':
			return 15;
			break;
		case 'T':
			return 16;
			break;
		case 'V':
			return 17;
			break;
		case 'W':
			return 18;
			break;
		case 'X':
			return 19;
			break;
		case 'Y':
			return 20;
			break;
		case 'Z':
			return 21;
			break;
		case '0':
			return 22;
			break;
		case '1':
			return 23;
			break;
		case '2':
			return 24;
			break;
		case '3':
			return 25;
			break;
		case '4':
			return 26;
			break;
		case '5':
			return 27;
			break;
		case '6':
			return 28;
			break;
		case '7':
			return 29;
			break;
		case '8':
			return 30;
			break;
		case '9':
			return 31;
			break;
		default:
			return -1;
			break;
	}
}

static char GenGetChar(int Genhexval)
{
	switch(Genhexval)
	{
		case 0:
			return 'A';
			break;
		case 1:
			return 'B';
			break;
		case 2:
			return 'C';
			break;
		case 3:
			return 'D';
			break;
		case 4:
			return 'E';
			break;
		case 5:
			return 'F';
			break;
		case 6:
			return 'G';
			break;
		case 7:
			return 'H';
			break;
		case 8:
			return 'J';
			break;
		case 9:
			return 'K';
			break;
		case 10:
			return 'L';
			break;
		case 11:
			return 'M';
			break;
		case 12:
			return 'N';
			break;
		case 13:
			return 'P';
			break;
		case 14:
			return 'R';
			break;
		case 15:
			return 'S';
			break;
		case 16:
			return 'T';
			break;
		case 17:
			return 'V';
			break;
		case 18:
			return 'W';
			break;
		case 19:
			return 'X';
			break;
		case 20:
			return 'Y';
			break;
		case 21:
			return 'Z';
			break;
		case 22:
			return '0';
			break;
		case 23:
			return '1';
			break;
		case 24:
			return '2';
			break;
		case 25:
			return '3';
			break;
		case 26:
			return '4';
			break;
		case 27:
			return '5';
			break;
		case 28:
			return '6';
			break;
		case 29:
			return '7';
			break;
		case 30:
			return '8';
			break;
		case 31:
			return '9';
			break;
		default:
			return 'd';
			break;
	}
}

DLLExport CString GenGGtoHex(CString GenGGcode)
{
	//AFX_MANAGE_STATE(AfxGetStaticModuleState());

	CString hcode="          ";
	char tchar[2]="";
	unsigned int mval=0;
	unsigned int mval2=0;

	for (mval=0;mval<=7;mval++)
	{
		if (GenGetVal(GenGGcode[(int) mval])==-1)
			return "----------";
	}

	mval = GenGetVal(GenGGcode[7]);
	mval |= (GenGetVal(GenGGcode[6]))<<5;
	mval |= (GenGetVal(GenGGcode[5]))<<10;
	mval |= (GenGetVal(GenGGcode[4]))<<15;
	mval2 = (GenGetVal(GenGGcode[3]));
	mval2 |= (GenGetVal(GenGGcode[2]))<<5;
	mval2 |= (GenGetVal(GenGGcode[1]))<<10;
	mval2 |= (GenGetVal(GenGGcode[0]))<<15;
	_itoa((mval2 & 983040)>>16,tchar,16);
	hcode.SetAt(8,tchar[0]);
	_itoa((mval2 & 61440)>>12,tchar,16);
	hcode.SetAt(9,tchar[0]);
	_itoa((mval2 & 3840)>>8,tchar,16);
	hcode.SetAt(2,tchar[0]);
	_itoa((mval2 & 240)>>4,tchar,16);
	hcode.SetAt(3,tchar[0]);
	_itoa(mval2 & 15,tchar,16);
	hcode.SetAt(0,tchar[0]);
	_itoa((mval & 983040)>>16,tchar,16);
	hcode.SetAt(1,tchar[0]);
	_itoa((mval & 30720)>>11,tchar,16);
	hcode.SetAt(7,tchar[0]);
	_itoa(((mval & 1792)>>7)|((mval & 32768)>>15),tchar,16);
	hcode.SetAt(6,tchar[0]);
	_itoa((mval & 240)>>4,tchar,16);
	hcode.SetAt(4,tchar[0]);
	_itoa(mval & 15,tchar,16);
	hcode.SetAt(5,tchar[0]);

	return hcode;
}

DLLExport CString GenHextoGG(CString GenHexcode)
{
	//AFX_MANAGE_STATE(AfxGetStaticModuleState());

	CString ggcode="        ";
	unsigned int mval=0;
	unsigned int mval2=0;

	for (mval=0;mval<=9;mval++)
	{
		if (chtoi(GenHexcode[(int) mval])==-1)
			return "--------";
	}

	mval = chtoi(GenHexcode[9]);
	mval |= (chtoi(GenHexcode[8]))<<4;
	mval |= (chtoi(GenHexcode[7]))<<8;
	mval |= (chtoi(GenHexcode[6]))<<12;
	mval |= (chtoi(GenHexcode[5]))<<16;
	mval2 = chtoi(GenHexcode[4]);
	mval2 |= (chtoi(GenHexcode[3]))<<4;
	mval2 |= (chtoi(GenHexcode[2]))<<8;
	mval2 |= (chtoi(GenHexcode[1]))<<12;
	mval2 |= (chtoi(GenHexcode[0]))<<16;
	ggcode.SetAt(0,GenGetChar((mval & 248)>>3));
	ggcode.SetAt(1,GenGetChar(((mval & 7)<<2) | ((mval2 & 3072)>>10)));
	ggcode.SetAt(2,GenGetChar((mval2 & 992)>>5));
	ggcode.SetAt(3,GenGetChar((mval2 & 16) | ((mval2 & 983040)>>16)));
	ggcode.SetAt(4,GenGetChar(((mval2 & 61440)>>11) | ((mval & 4096)>>12)));
	ggcode.SetAt(5,GenGetChar(((mval & 3840)>>7) | ((mval & 32768)>>15)));
	ggcode.SetAt(6,GenGetChar(((mval & 24576)>>10) | ((mval2 & 14)>>1)));
	ggcode.SetAt(7,GenGetChar(((mval2 & 1)<<4) | ((mval & 983040)>>16)));

	return ggcode;
}

//----------------
//Game Boy/Game Gear functions
DLLExport CString GB6GGtoHex(CString GB6GGcode, bool GameGear=FALSE)
{
	//AFX_MANAGE_STATE(AfxGetStaticModuleState());

	CString hcode="      ";
	char tchar[2]="";
	unsigned int mval=0;

	for (mval=0;mval<=5;mval++)
	{
		if (chtoi(GB6GGcode[(int) mval])==-1)
			return "------";
	}

	mval = chtoi(GB6GGcode[5]);
	if (GameGear)
	{
		if (mval < 4)
			return "------";
	}
	else
	{
		if (mval<8)
			mval += 8;
	}
	mval ^= 0x0F;
	_itoa(mval,tchar,16);
	hcode.SetAt(0,toupper(tchar[0]));

	hcode.SetAt(1,GB6GGcode[2]);
	hcode.SetAt(2,GB6GGcode[3]);
	hcode.SetAt(3,GB6GGcode[4]);
	hcode.SetAt(4,GB6GGcode[0]);
	hcode.SetAt(5,GB6GGcode[1]);

	return hcode;
}

DLLExport CString GB9GGtoHex(CString GB9GGcode, bool GameGear=FALSE)
{
	//AFX_MANAGE_STATE(AfxGetStaticModuleState());

	CString hcode="         ";
	char tchar[2]="";
	unsigned int mval=0;

	for (mval=0;mval<=8;mval++)
	{
		if (chtoi(GB9GGcode[(int) mval])==-1)
			return "---------";
	}

	mval = chtoi(GB9GGcode[5]);
	if (GameGear)
	{
		if (mval < 4)
			return "---------";
	}
	else
	{
		if (mval<8)
			mval += 8;
	}
	mval ^= 0x0F;
	_itoa(mval,tchar,16);
	hcode.SetAt(0,toupper(tchar[0]));

	hcode.SetAt(1,GB9GGcode[2]);
	hcode.SetAt(2,GB9GGcode[3]);
	hcode.SetAt(3,GB9GGcode[4]);
	hcode.SetAt(7,GB9GGcode[0]);
	hcode.SetAt(8,GB9GGcode[1]);

	mval = chtoi(GB9GGcode[6]) << 4;
	mval += chtoi(GB9GGcode[8]);
	mval |= (mval & 3) << 8;
	mval >>= 2;
	mval ^= 0xBA;
	_itoa((mval&0xF0)>>4,tchar,16);
	hcode.SetAt(4,toupper(tchar[0]));
	_itoa(mval&0x0F,tchar,16);
	hcode.SetAt(5,toupper(tchar[0]));
	mval = chtoi(GB9GGcode[6]) ^ chtoi(GB9GGcode[7]);
	_itoa(mval,tchar,16);
	hcode.SetAt(6,toupper(tchar[0]));

	return hcode;
}

DLLExport CString GB6HextoGG(CString GB6Hexcode, bool GameGear=FALSE)
{
	//AFX_MANAGE_STATE(AfxGetStaticModuleState());

	CString gcode="      ";
	char tchar[2]="";
	unsigned int mval=0;

	for (mval=0;mval<=5;mval++)
	{
		if (chtoi(GB6Hexcode[(int) mval])==-1)
			return "------";
	}

	gcode.SetAt(0,GB6Hexcode[4]);
	gcode.SetAt(1,GB6Hexcode[5]);
	gcode.SetAt(2,GB6Hexcode[1]);
	gcode.SetAt(3,GB6Hexcode[2]);
	gcode.SetAt(4,GB6Hexcode[3]);

	mval = chtoi(GB6Hexcode[0]);
	if (GameGear)
	{
		if (mval >= 0xC)
			return "------";
	}
	else
	{
		if (mval>=8)
			mval -= 8;
	}
	mval ^= 0x0F;
	_itoa(mval,tchar,16);
	gcode.SetAt(5,toupper(tchar[0]));

	return gcode;
}

DLLExport CString GB9HextoGG(CString GB9Hexcode, bool GameGear=FALSE)
{
	//AFX_MANAGE_STATE(AfxGetStaticModuleState());

	CString gcode="         ";
	char tchar[2]="";
	unsigned int mval=0;

	for (mval=0;mval<=8;mval++)
	{
		if (chtoi(GB9Hexcode[(int) mval])==-1)
			return "---------";
	}

	gcode.SetAt(0,GB9Hexcode[7]);
	gcode.SetAt(1,GB9Hexcode[8]);
	gcode.SetAt(2,GB9Hexcode[1]);
	gcode.SetAt(3,GB9Hexcode[2]);
	gcode.SetAt(4,GB9Hexcode[3]);

	mval = chtoi(GB9Hexcode[0]);
	if (GameGear)
	{
		if (mval >= 0xC)
			return "---------";
	}
	else
	{
		if (mval>=8)
			mval -= 8;
	}
	mval ^= 0x0F;
	_itoa(mval,tchar,16);
	gcode.SetAt(5,toupper(tchar[0]));

	mval = chtoi(GB9Hexcode[4]) << 4;
	mval += chtoi(GB9Hexcode[5]);
	mval ^= 0xBA;
	mval <<= 2;
	mval |= (mval & 0x300) >> 8;
	mval &= 0xFF;
	_itoa((mval&0xF0)>>4,tchar,16);
	gcode.SetAt(6,toupper(tchar[0]));
	_itoa(mval&0x0F,tchar,16);
	gcode.SetAt(8,toupper(tchar[0]));
	mval = chtoi(gcode[6]) ^ chtoi(GB9Hexcode[6]);
	_itoa(mval,tchar,16);
	gcode.SetAt(7,toupper(tchar[0]));

	return gcode;
}